#include <ant/alloc.h>
#include <ant/io.h>

int main(int argc, char **argv) {
    FILE *in = efopen(argv[1], "rb");
    
    unsigned long cookie;
    unsigned long version;
    unsigned long numchars;
    unsigned long height;
    unsigned long baseline;
    unsigned long i;
    unsigned long offset;
    unsigned long *offsets;
    unsigned long width;
    unsigned long spacing;
    char *outfilename = emalloc(strlen(argv[2]) + 16);

    cookie = readlongbe(in);
    fprintf(stderr, "Cookie: %lx\n", cookie);
    if (cookie != 0x464f4e54) return 1;

    version = readlongbe(in);
    fprintf(stderr, "version: %lx\n", version);

    numchars = readlongbe(in);
    fprintf(stderr, "numchars: %lu\n", numchars);

    height = readlongbe(in);
    fprintf(stderr, "height: %lu\n", height);

    baseline = readlongbe(in);
    fprintf(stderr, "baseline: %lu\n", baseline);

    offsets = emalloc(numchars * sizeof(*offsets));
    for (i = 0; i < numchars; i++) {
	offset = readlongbe(in);
	offsets[i] = offset;
	/* fprintf(stderr, "char %lu: offset: %lu\n", i, offset); */

    }

    for (i = 0; i < numchars; i++) {
	FILE *out;
	int wbytes;
	int j, k;
	fseek(in, offsets[i], SEEK_SET);
	width = readlongbe(in);
	spacing = readlongbe(in);
	if (width == 0) continue;
	fprintf(stderr, "char %lu: width: %lu, spacing: %lu\n", i, width, spacing);
	sprintf(outfilename, "%s.%lu.pgm", argv[2], i);
	out = efopen(outfilename, "wb");
	fprintf(out, "P5\n%lu %lu\n%d\n", width, height, 255);
	wbytes = width + 7 / 8;
	for (j = 0; j < height; j++) {
	    for (k = 0; k < wbytes; k++) {
		putc(getc(in), out);
	    }
	}
	efclose(out);

    }


    return 0;

}
