#ifndef I_pixmap_h
#define I_pixmap_h

#include <limits.h>

#if UINT_MAX >= 0xFFFFFFFF
typedef unsigned int pixelT;
#else
typedef unsigned long pixelT;
#endif

typedef struct pixmapT {
    int rows, cols;
    pixelT **pixels;
}

pixmapT;

#define blue(pixel)  ((pixel) & 255)
#define green(pixel) (((pixel) >> 8) & 255)
#define red(pixel)   (((pixel) >> 16) & 255)
#define alpha(pixel) (((pixel) >> 24) & 255)
	/* Alpha is opacity here, not transparency:
         * 0 is fully transparent, 255 is fully opaque.
         * (PNG uses the same definition)
         */
#define pixel(alpha, red, green, blue) \
                     (((((((alpha) << 8) | (red)) << 8) | (green)) << 8) | (blue))



pixmapT *alloc_pixmap(int rows, int cols);
void pixmap_replace(
		       pixmapT * dst,
		       pixmapT * src,
		       int xoff, int yoff
);
void write_pixmap(const char *fn, pixmapT * pixmap);
#endif
